/************************************************

	generiert Masken fuer Layoutprogramm
	license: GNU GPL 2+ (see ../COPYING)

************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define USAGE	fprintf(stderr,"USAGE: gen file nx ny dx dy\n"), exit(1)

int main(argc, argv)
int 	argc;
char	*argv[];
{
	int 	nx, ny, x, y, dx, dy;
	int 	i, j;
	FILE	*fp;
	
	argc--;
	argv++;
	if (argc != 5) 
		USAGE;
	nx = atoi(argv[1]);
	ny = atoi(argv[2]);
	dx = atoi(argv[3]);
	dy = atoi(argv[4]);
	if ((fp = fopen(argv[0], "w")) == NULL)
	{
		fprintf(stderr, "can't open file\n");
		exit(1);
	}
	x = 0;
	for (i = 0; i < nx; i++)
	{
		y = 0;
		for (j = 0; j < ny; j++, y += dy)
			fprintf(fp, "%3i %3i \n", x, y);
		x += dx;
	}
	fclose(fp);
	return(0);
}
