XSCREEN         equ     639
YSCREEN         equ     399
LINELEN			equ		80

				export	o_scrinit, o_clrscr
				export	o_clrstat, o_cursor
				export	o_status
				export	o_hordot, o_verdot
				export	o_urdot, o_drdot
				export	o_chline, o_cblk
				export	o_chdlin, o_cdblk

                text

o_scrinit:		move.l	a0,scrbase		* setzt Bildschirmaddresse {sets screen address}
				lea		o_font,a0		* kopiert small font
				move	#255,d0
o_scr_1:		move.b	0*256(a1),(a0)+
				move.b	1*256(a1),(a0)+
				move.b	2*256(a1),(a0)+
				move.b	3*256(a1),(a0)+
				move.b	4*256(a1),(a0)+
				move.b	5*256(a1),(a0)+
				move.b	6*256(a1),(a0)+
				move.b	7*256(a1),(a0)+
				lea		1(a1),a1
				dbra	d0,o_scr_1
				rts

o_clrstat:		move.l	scrbase,a0		* loescht Statuszeile
				lea		(YSCREEN-7)*LINELEN(a0),a0
				move.l	#0,d0
				move	#(LINELEN/4)-1,d1
o_clst_1:		move.l	d0,7*LINELEN(a0)
				move.l	d0,6*LINELEN(a0)
				move.l	d0,5*LINELEN(a0)
				move.l	d0,4*LINELEN(a0)
				move.l	d0,3*LINELEN(a0)
				move.l	d0,2*LINELEN(a0)
				move.l	d0,1*LINELEN(a0)
				move.l	d0,(a0)+
				dbra	d1,o_clst_1
				rts

o_status:		move.l	a2,-(sp)		* String in Statuszeile
				lea		o_font,a2
				move.l	scrbase,a1
				lea		(YSCREEN-7)*LINELEN(a1),a1
				move.b	(a0)+,d0
				bra		o_st_2
o_st_1:			and		#$ff,d0
				lsl		#3,d0
				move.b	0(d0,a2),0*LINELEN(a1)
				move.b	1(d0,a2),1*LINELEN(a1)
				move.b	2(d0,a2),2*LINELEN(a1)
				move.b	3(d0,a2),3*LINELEN(a1)
				move.b	4(d0,a2),4*LINELEN(a1)
				move.b	5(d0,a2),5*LINELEN(a1)
				move.b	6(d0,a2),6*LINELEN(a1)
				move.b	7(d0,a2),7*LINELEN(a1)
				lea		1(a1),a1
				move.b	(a0)+,d0
o_st_2:			bne		o_st_1
				move.l	(sp)+,a2
				rts

o_cursor:		move.l	scrbase,a0		* zeichnet cursor XOR mode {draw cursor in XOR mode}
				move.l	a0,a1
				mulu	#LINELEN,d1
				lea		(a0,d1),a0
				move.l	#%01010101010101010101010101010101,d1
				move	#LINELEN/16-1,d2
o_cur_1:		eor.l	d1,(a0)+
				eor.l	d1,(a0)+
				eor.l	d1,(a0)+
				eor.l	d1,(a0)+
				dbra	d2,o_cur_1
				move	d0,d2
				lsr		#3,d2
				and		#$fffe,d2
				lea		LINELEN(a1,d2),a1
				and		#$f,d0
				lsl		d0
				lea		one_tab,a0
				move	(a0,d0),d0
				move	#(YSCREEN+1)/4-1,d2
				move	#4*LINELEN,d1
o_cur_2:		eor		d0,(a1)
				eor		d0,2*LINELEN(a1)
				adda	d1,a1
				dbra	d2,o_cur_2
				rts
										* loescht Bildschirm
o_clrscr:		movem.l	d3-d5/a2-a3,-(sp)
				move.l	scrbase,a0
				add.l	#400*LINELEN,a0
				clr.l	d1
				move.l	d1,d2
				move.l	d1,d3
				move.l	d1,d4
				move.l	d1,d5
				move.l	d1,d6
				move.l	d1,d7
				move.l	d1,a1
				move.l	d1,a2
				move.l	d1,a3
				move	#(YSCREEN+1)/4-1,d0
cl_1:			movem.l	d1-d7/a1-a3,-(a0)
				movem.l	d1-d7/a1-a3,-(a0)
				movem.l	d1-d7/a1-a3,-(a0)
				movem.l	d1-d7/a1-a3,-(a0)
				movem.l	d1-d7/a1-a3,-(a0)
				movem.l	d1-d7/a1-a3,-(a0)
				movem.l	d1-d7/a1-a3,-(a0)
				movem.l	d1-d7/a1-a3,-(a0)
				dbra	d0,cl_1
				movem.l	(sp)+,d3-d5/a2-a3
				rts

o_hordot:		move.l	a2,-(sp)		* horizontal gepunktete Linie {horizontal dotted line}
				cmp		d0,d1
				bge		o_hord_4
				exg		d0,d1
o_hord_4:		tst		d0
				bge		o_horc_1
				move	#0,d0
o_horc_1:		cmp		#XSCREEN,d1
				ble		o_horc_2
				move	#XSCREEN,d1
o_horc_2:		tst		d2
				blt		o_hord_x
				cmp		#YSCREEN,d2
				bgt		o_hord_x
				cmp		d0,d1
				blt		o_hord_x
				move.l	scrbase,a0
				mulu	#LINELEN,d2
				lea		(a0,d2),a0
				move.l	a0,a1
				move	d0,d2
				lsr		#3,d2
				and		#$fffe,d2
				lea		(a0,d2),a0
				move	d1,d2
				lsr		#3,d2
				and		#$fffe,d2
				lea		(a1,d2),a1
				lea		xor_ltab,a2
				and		#$e,d0
				move	(a2,d0),d0
				lea		xor_rtab,a2
				and		#$e,d1
				move	(a2,d1),d1
				cmp.l	a1,a0
				bge		o_hord_1
				eor		d0,(a0)+
				move	#%1010101010101010,d0
				bra		o_hord_3
o_hord_2:		eor		d0,(a0)+
o_hord_3:		cmp.l	a1,a0
				blt		o_hord_2
o_hord_1:		and		d1,d0
				eor		d0,(a1)
o_hord_x:		move.l	(sp)+,a2
				rts

o_verdot:		cmp		d1,d2		* vertikal gepunktete Linie
				bge		o_verd_2
				exg		d1,d2
o_verd_2:		tst		d0
				blt		o_verd_x
				cmp		#XSCREEN,d0
				bgt		o_verd_x
				tst		d1
				bge		o_verc_1
				move	#0,d1
o_verc_1:		cmp		#YSCREEN,d2
				ble		o_verc_2
				move	#YSCREEN,d2
o_verc_2:		sub		d1,d2
				bmi		o_verd_x
				lsr		d2
				move.l	scrbase,a0
				mulu	#LINELEN,d1
				lea		(a0,d1),a0
				move	d0,d1
				lsr		#3,d1
				and		#$fffe,d1
				lea		(a0,d1),a0
				lea		one_tab,a1
				and		#$f,d0
				lsl		d0
				move	(a1,d0),d0
				move	#LINELEN,d1
				lsl		d1
o_verd_1:		eor		d0,(a0)
				add.w	d1,a0
				dbra	d2,o_verd_1
o_verd_x:		rts

o_urdot:		move.l	d3,-(sp)		* gepunktet hoch rechts
				move	8(sp),d3
				cmp		d0,d2
				bge		o_urd_1
				exg		d0,d2
				exg		d1,d3
o_urd_1:		tst		d0
				bge		o_urc_1
				sub		d0,d1
				sub		d0,d0
o_urc_1:		tst		d1
				bge		o_urc_2
				sub		d1,d0
				sub		d1,d1
o_urc_2:		cmp		#XSCREEN,d2
				ble		o_urc_3
				sub		#XSCREEN,d2
				sub		d2,d3
				move	#XSCREEN,d2
o_urc_3:		cmp		#YSCREEN,d3
				ble		o_urc_4
				sub		#YSCREEN,d3
				sub		d3,d2
				move	#YSCREEN,d3
o_urc_4:		cmp		d0,d2
				blt		o_urd_x
				sub		d1,d3
				bmi		o_urd_x
				lsr		d3
				move.l	scrbase,a0
				mulu	#LINELEN,d1
				lea		(a0,d1),a0
				move	d0,d1
				lsr		#3,d1
				and		#$fffe,d1
				lea		(a0,d1),a0
				lea		one_tab,a1
				and		#$f,d0
				move	#15,d2
				sub		d0,d2
				lsl		d0
				move	(a1,d0),d0
				move	#2*LINELEN,d1
o_urd_2:		eor		d0,(a0)
				add.w	d1,a0
				ror		#2,d0
				sub		#2,d2
				dbmi	d3,o_urd_2
				add		#16,d2
				lea		2(a0),a0
				sub		#1,d3
				bpl		o_urd_2
o_urd_x:		move.l	(sp)+,d3
				rts

o_drdot:		move.l	d3,-(sp)		* gepunktet hoch runter
				move	8(sp),d3
				cmp		d0,d2
				bge		o_drd_1
				exg		d0,d2
				exg		d1,d3
o_drd_1:		tst		d0
				bge		o_drc_1
				add		d0,d1
				sub		d0,d0
o_drc_1:		tst		d3
				bge		o_drc_2
				add		d3,d0
				sub		d3,d3
o_drc_2:		cmp		#XSCREEN,d2
				ble		o_drc_3
				sub		#XSCREEN,d2
				add		d2,d3
				move	#XSCREEN,d2
o_drc_3:		cmp		#YSCREEN,d1
				ble		o_drc_4
				sub		#YSCREEN,d1
				add		d1,d2
				move	#YSCREEN,d1
o_drc_4:		cmp		d0,d2
				blt		o_drd_x
				sub		d1,d3
				bgt		o_drd_x
				neg		d3
				lsr		d3
				move.l	scrbase,a0
				mulu	#LINELEN,d1
				lea		(a0,d1),a0
				move	d0,d1
				lsr		#3,d1
				and		#$fffe,d1
				lea		(a0,d1),a0
				lea		one_tab,a1
				and		#$f,d0
				move	#15,d2
				sub		d0,d2
				lsl		d0
				move	(a1,d0),d0
				move	#2*LINELEN,d1
o_drd_2:		eor		d0,(a0)
				sub.w	d1,a0
				ror		#2,d0
				sub		#2,d2
				dbmi	d3,o_drd_2
				add		#16,d2
				lea		2(a0),a0
				sub		#1,d3
				bpl		o_drd_2
o_drd_x:		move.l	(sp)+,d3
				rts

o_chline:		move.l	a2,-(sp)		* horizontal geclippte Linie
				cmp		d0,d1
				bge		o_chl_1
				exg		d0,d1
o_chl_1:		tst		d2
				blt		o_chl_x
				cmp		#YSCREEN,d2
				bgt		o_chl_x
				tst		d0
				bge		o_chl_2
				move	#0,d0
o_chl_2:		cmp		#XSCREEN,d1
				ble		o_chl_3
				move	#XSCREEN,d1
o_chl_3:		cmp		d1,d0
				bgt		o_chl_x
				move.l	scrbase,a0
				mulu	#LINELEN,d2
				lea		(a0,d2),a0
				move.l	a0,a1
				move	d0,d2
				lsr		#3,d2
				and		#$fffe,d2
				lea		(a0,d2),a0
				move	d1,d2
				lsr		#3,d2
				and		#$fffe,d2
				lea		(a1,d2),a1
				lea		left_tab,a2
				and		#$f,d0
				lsl		d0
				move	(a2,d0),d0
				lea		right_tab,a2
				and		#$f,d1
				lsl		d1
				move	(a2,d1),d1
				cmp.l	a1,a0
				bge		o_chl_6
				or		d0,(a0)+
				move	#$ffff,d0
				bra		o_chl_5
o_chl_4:		or		d0,(a0)+
o_chl_5:		cmp.l	a1,a0
				blt		o_chl_4
o_chl_6:		and		d1,d0
				or		d0,(a1)
o_chl_x:		move.l	(sp)+,a2
				rts

o_cblk:			movem.l	d3-d4/a2,-(sp)		* geclippter Block
				move	16(sp),d3
				cmp		d0,d2
				bge		o_cb_1
				exg		d0,d2
o_cb_1:			cmp		d1,d3
				bge		o_cb_2
				exg		d1,d3
o_cb_2:			tst		d0
				bge		o_cb_3
				move	#0,d0
o_cb_3:			tst		d1
				bge		o_cb_4
				move	#0,d1
o_cb_4:			cmp		#XSCREEN,d2
				ble		o_cb_5
				move	#XSCREEN,d2
o_cb_5:			cmp		#YSCREEN,d3
				ble		o_cb_6
				move	#YSCREEN,d3
o_cb_6:			cmp		d2,d0
				bgt		o_cb_x
				sub		d1,d3			* delta y
				bmi		o_cb_x
				move.l	scrbase,a0
				mulu	#LINELEN,d1
				lea		(a0,d1),a0
				move.l	a0,a1
				move	d0,d1
				lsr		#3,d1
				and		#$fffe,d1
				lea		(a0,d1),a0		* Startaddresse
				move	d2,d1
				lsr		#3,d1
				and		#$fffe,d1
				lea		(a1,d1),a1
				lea		left_tab,a2
				and		#$f,d0			* Startmuster
				lsl		d0
				move	(a2,d0),d0
				move	d0,d1			* gespeichertes Muster
				lea		right_tab,a2
				and		#$f,d2
				lsl		d2
				move	(a2,d2),d2		* Endmuster
				move	#LINELEN,d4
o_cb_7:			lea		(a0,d4),a2		* neue Startaddresse
				cmp.l	a1,a0
				bge		o_cb_10
				or		d0,(a0)+
				move	#$ffff,d0
				bra		o_cb_9
o_cb_8:			or		d0,(a0)+
o_cb_9:			cmp.l	a1,a0
				blt		o_cb_8
o_cb_10:		and		d2,d0
				or		d0,(a1)
				move.l	a2,a0
				move	d1,d0
				lea		(d4,a1),a1
				dbra	d3,o_cb_7
o_cb_x:			movem.l	(sp)+,d3-d4/a2
				rts

o_chdlin:		move.l	a2,-(sp)		* horizontal geclippte Linie
				cmp		d0,d1			* loeschen
				bge		o_chld1
				exg		d0,d1
o_chld1:		tst		d2
				blt		o_chldx
				cmp		#YSCREEN,d2
				bgt		o_chldx
				tst		d0
				bge		o_chld2
				move	#0,d0
o_chld2:		cmp		#XSCREEN,d1
				ble		o_chld3
				move	#XSCREEN,d1
o_chld3:		cmp		d1,d0
				bgt		o_chldx
				move.l	scrbase,a0
				mulu	#LINELEN,d2
				lea		(a0,d2),a0
				move.l	a0,a1
				move	d0,d2
				lsr		#3,d2
				and		#$fffe,d2
				lea		(a0,d2),a0
				move	d1,d2
				lsr		#3,d2
				and		#$fffe,d2
				lea		(a1,d2),a1
				lea		left_tab,a2
				and		#$f,d0
				lsl		d0
				move	(a2,d0),d0
				not		d0
				lea		right_tab,a2
				and		#$f,d1
				lsl		d1
				move	(a2,d1),d1
				not		d1
				cmp.l	a1,a0
				bge		o_chld6
				and		d0,(a0)+
				move	#0,d0
				bra		o_chld5
o_chld4:		and		d0,(a0)+
o_chld5:		cmp.l	a1,a0
				blt		o_chld4
o_chld6:		or		d1,d0
				and		d0,(a1)
o_chldx:		move.l	(sp)+,a2
				rts

o_cdblk:		movem.l	d3-d4/a2,-(sp)		* geclippter Block
				move	16(sp),d3			* loeschen
				cmp		d0,d2
				bge		o_cbd1
				exg		d0,d2
o_cbd1:			cmp		d1,d3
				bge		o_cbd2
				exg		d1,d3
o_cbd2:			tst		d0
				bge		o_cbd3
				move	#0,d0
o_cbd3:			tst		d1
				bge		o_cbd4
				move	#0,d1
o_cbd4:			cmp		#XSCREEN,d2
				ble		o_cbd5
				move	#XSCREEN,d2
o_cbd5:			cmp		#YSCREEN,d3
				ble		o_cbd6
				move	#YSCREEN,d3
o_cbd6:			cmp		d2,d0
				bgt		o_cbdx
				sub		d1,d3			* delta y
				bmi		o_cbdx
				move.l	scrbase,a0
				mulu	#LINELEN,d1
				lea		(a0,d1),a0
				move.l	a0,a1
				move	d0,d1
				lsr		#3,d1
				and		#$fffe,d1
				lea		(a0,d1),a0		* Startaddresse
				move	d2,d1
				lsr		#3,d1
				and		#$fffe,d1
				lea		(a1,d1),a1
				lea		left_tab,a2
				and		#$f,d0			* Startmuster
				lsl		d0
				move	(a2,d0),d0
				not		d0
				move	d0,d1			* gespeichertes Muster
				lea		right_tab,a2
				and		#$f,d2
				lsl		d2
				move	(a2,d2),d2		* Endmuster
				not		d2
				move	#LINELEN,d4
o_cbd7:			lea		(a0,d4),a2		* neue Startaddresse
				cmp.l	a1,a0
				bge		o_cbd10
				and		d0,(a0)+
				move	#0,d0
				bra		o_cbd9
o_cbd8:			and		d0,(a0)+
o_cbd9:			cmp.l	a1,a0
				blt		o_cbd8
o_cbd10:		or		d2,d0
				and		d0,(a1)
				move.l	a2,a0
				move	d1,d0
				lea		(d4,a1),a1
				dbra	d3,o_cbd7
o_cbdx:			movem.l	(sp)+,d3-d4/a2
				rts

                data
				even

left_tab:       dc.w    %1111111111111111, %0111111111111111
                dc.w    %0011111111111111, %0001111111111111
                dc.w    %0000111111111111, %0000011111111111
                dc.w    %0000001111111111, %0000000111111111
                dc.w    %0000000011111111, %0000000001111111
                dc.w    %0000000000111111, %0000000000011111
                dc.w    %0000000000001111, %0000000000000111
                dc.w    %0000000000000011, %0000000000000001
                        
right_tab:      dc.w    %1000000000000000, %1100000000000000
                dc.w    %1110000000000000, %1111000000000000
                dc.w    %1111100000000000, %1111110000000000
                dc.w    %1111111000000000, %1111111100000000
                dc.w    %1111111110000000, %1111111111000000
                dc.w    %1111111111100000, %1111111111110000
                dc.w    %1111111111111000, %1111111111111100
                dc.w    %1111111111111110, %1111111111111111
 
one_tab:		dc.w    %1000000000000000, %0100000000000000
                dc.w    %0010000000000000, %0001000000000000
                dc.w    %0000100000000000, %0000010000000000
                dc.w    %0000001000000000, %0000000100000000
                dc.w    %0000000010000000, %0000000001000000
                dc.w    %0000000000100000, %0000000000010000
                dc.w    %0000000000001000, %0000000000000100
                dc.w    %0000000000000010, %0000000000000001

xor_ltab:		dc.w	%1010101010101010, %0010101010101010
				dc.w	%0000101010101010, %0000001010101010
				dc.w	%0000000010101010, %0000000000101010
				dc.w	%0000000000001010, %0000000000000010

xor_rtab:		dc.w	%1000000000000000, %1010000000000000
				dc.w	%1010100000000000, %1010101000000000
				dc.w	%1010101010000000, %1010101010100000
				dc.w	%1010101010101000, %1010101010101010
                       
				bss
				even

scrbase:		ds.l	1
o_font:			ds.b	8*256

				end
